<?php namespace MapGuesser\PersistentData\Model;

use SokoWeb\PersistentData\Model\Model;

class PlaceInChallenge extends Model
{
    protected static string $table = 'place_in_challenge';

    protected static array $fields = ['place_id', 'challenge_id', 'round'];

    protected static array $relations = ['place' => Place::class, 'challenge' => Challenge::class];

    private ?Place $place = null;

    private ?int $placeId = null;

    private ?Challenge $challenge = null;

    private ?int $challengeId = null;

    private int $round;

    public function setPlace(Place $place): void
    {
        $this->place = $place;
    }

    public function setPlaceId(int $placeId): void
    {
        $this->placeId = $placeId;
    }

    public function setChallenge(Challenge $challenge): void
    {
        $this->challenge = $challenge;
    }

    public function setChallengeId(int $challengeId): void
    {
        $this->challengeId = $challengeId;
    }

    public function setRound(int $round): void
    {
        $this->round = $round;
    }

    public function getPlace(): ?Place
    {
        return $this->place;
    }

    public function getPlaceId(): ?int
    {
        return $this->placeId;
    }

    public function getChallenge(): ?Challenge
    {
        return $this->challenge;
    }

    public function getChallengeId(): ?int
    {
        return $this->challengeId;
    }

    public function getRound(): int
    {
        return $this->round;
    }
}
